import numpy

class Cuboide :
	K = numpy.matrix( [ [1000.0,    0.0, -300.0],
	                  [   0.0,   1000.0, -200.0],
	                  [   0.0,      0.0,   -1.0] ] )

	def __init__( self ) :
		self.v = numpy.zeros( (8,3) ) 
		self.img = numpy.zeros( (8,2) ) 


	def Crea( self, v1, v7 ) :
		self.v[0][0] = v1[0] 
		self.v[0][1] = v1[1]
		self.v[0][2] = v1[2]

		self.v[1][0] = v1[0] 
		self.v[1][1] = v1[1]
		self.v[1][2] = v7[2]

		self.v[2][0] = v7[0] 
		self.v[2][1] = v1[1]
		self.v[2][2] = v7[2]

		self.v[3][0] = v7[0] 
		self.v[3][1] = v1[1]
		self.v[3][2] = v1[2]

		self.v[4][0] = v1[0] 
		self.v[4][1] = v7[1]
		self.v[4][2] = v1[2]

		self.v[5][0] = v1[0] 
		self.v[5][1] = v7[1]
		self.v[5][2] = v7[2]

		self.v[6][0] = v7[0] 
		self.v[6][1] = v7[1]
		self.v[6][2] = v7[2]

		self.v[7][0] = v7[0] 
		self.v[7][1] = v7[1]
		self.v[7][2] = v1[2]

	def dibujaCara( self, cara ) :
		# 2 3 6 7
		print self.v[cara[0]][0], self.v[cara[0]][1], self.v[cara[0]][2] 
		print self.v[cara[1]][0], self.v[cara[1]][1], self.v[cara[1]][2] 
		print self.v[cara[2]][0], self.v[cara[2]][1], self.v[cara[2]][2] 
		print self.v[cara[3]][0], self.v[cara[3]][1], self.v[cara[3]][2] 
		print self.v[cara[0]][0], self.v[cara[0]][1], self.v[cara[0]][2] 
		print
		print

	def Dibuja3D( self ) :
		self.dibujaCara( (1, 2, 6, 5) )
		self.dibujaCara( (0, 4, 7, 3) )
		self.dibujaCara( (2, 3, 7, 6) )
		self.dibujaCara( (0, 1, 5, 4) )
		self.dibujaCara( (4, 5, 6, 7) )
		self.dibujaCara( (0, 3, 2, 1) )

	def dibujaCara2D( self, cara ) :
		# 2 3 6 7
		print self.img[cara[0]][0], self.img[cara[0]][1]
		print self.img[cara[1]][0], self.img[cara[1]][1]
		print self.img[cara[2]][0], self.img[cara[2]][1]
		print self.img[cara[3]][0], self.img[cara[3]][1]
		print self.img[cara[0]][0], self.img[cara[0]][1]
		print

	def Dibuja2D( self ) :
		self.dibujaCara2D( (1, 2, 6, 5) )
		self.dibujaCara2D( (0, 4, 7, 3) )
		self.dibujaCara2D( (2, 3, 7, 6) )
		self.dibujaCara2D( (0, 1, 5, 4) )
		self.dibujaCara2D( (4, 5, 6, 7) )
		self.dibujaCara2D( (0, 3, 2, 1) )

	def Proyecta( self, vo, vc, va ) :
		v2 = vc - vo
		k = numpy.linalg.norm( v2 )
		vz = v2 / k

		v3 = numpy.cross( va, vz )
		vx = v3/numpy.linalg.norm(v3)

		vy = numpy.cross( vz, vx )

		R = numpy.matrix ( [ vx, vy, vz ] )
		# print R

		vp = numpy.matrix( [ [0.0], [0.0], [0.0]] )
		i = 0
		while i<8 :
			vr = self.v[i]
			#
			# Aplicamos vp = T(-c) vr
			# 
			vp[0] = vr[0] - vc[0]
			vp[1] = vr[1] - vc[1]
			vp[2] = vr[2] - vc[2]

			v3 = R * vp
			v2 = Cuboide.K * v3

			self.img[i][0] = v2[0]/v2[2]
			self.img[i][1] = v2[1]/v2[2]

			i += 1

